GDAL

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Attributes | List of all members
OGRFeature Class Reference

A simple feature, including geometry and attributes. More...

`#include <ogr_feature.h>`

## Public Member Functions
| OGRFeature (OGRFeatureDefn *)
| Constructor. More...
OGRFeatureDefn * | GetDefnRef ()
| Fetch feature definition. More...
OGRErr | SetGeometryDirectly (OGRGeometry *)
| Set feature geometry. More...
OGRErr | SetGeometry (OGRGeometry *)
| Set feature geometry. More...
OGRGeometry * | GetGeometryRef ()
| Fetch pointer to feature geometry. More...
OGRGeometry * | StealGeometry () CPL_WARN_UNUSED_RESULT
| Take away ownership of geometry. More...
int | GetGeomFieldCount ()
| Fetch number of geometry fields on this feature. More...
OGRGeomFieldDefn * | GetGeomFieldDefnRef (int iField)
| Fetch definition for this geometry field. More...
int | GetGeomFieldIndex (const char *pszName)
| Fetch the geometry field index given geometry field name. More...
OGRGeometry * | GetGeomFieldRef (int iField)
| Fetch pointer to feature geometry. More...
OGRGeometry * | StealGeometry (int iField)
OGRGeometry * | GetGeomFieldRef (const char *pszFName)
| Fetch pointer to feature geometry. More...
OGRErr | SetGeomFieldDirectly (int iField, OGRGeometry *)
| Set feature geometry of a specified geometry field. More...
OGRErr | SetGeomField (int iField, OGRGeometry *)
| Set feature geometry of a specified geometry field. More...
OGRFeature * | Clone () CPL_WARN_UNUSED_RESULT
| Duplicate feature. More...
virtual OGRBoolean | Equal (OGRFeature *poFeature)
| Test if two features are the same. More...
int | GetFieldCount ()
| Fetch number of fields on this feature. More...
OGRFieldDefn * | GetFieldDefnRef (int iField)
| Fetch definition for this field. More...
int | GetFieldIndex (const char *pszName)
| Fetch the field index given field name. More...
int | IsFieldSet (int iField)
| Test if a field has ever been assigned a value or not. More...
void | UnsetField (int iField)
| Clear a field, marking it as unset. More...
OGRField * | GetRawFieldRef (int i)
| Fetch a pointer to the internal field value given the index. More...
int | GetFieldAsInteger (int i)
| Fetch field value as integer. More...
GIntBig | GetFieldAsInteger64 (int i)
| Fetch field value as integer 64 bit. More...
double | GetFieldAsDouble (int i)
| Fetch field value as a double. More...
const char * | GetFieldAsString (int i)
| Fetch field value as a string. More...
const int * | GetFieldAsIntegerList (int i, int *pnCount)
| Fetch field value as a list of integers. More...
const GIntBig * | GetFieldAsInteger64List (int i, int *pnCount)
| Fetch field value as a list of 64 bit integers. More...
const double * | GetFieldAsDoubleList (int i, int *pnCount)
| Fetch field value as a list of doubles. More...
char ** | GetFieldAsStringList (int i)
| Fetch field value as a list of strings. More...
GByte * | GetFieldAsBinary (int i, int *pnCount)
| Fetch field value as binary data. More...
int | GetFieldAsDateTime (int i, int *pnYear, int *pnMonth, int *pnDay, int *pnHour, int *pnMinute, int *pnSecond, int *pnTZFlag)
int | GetFieldAsDateTime (int i, int *pnYear, int *pnMonth, int *pnDay, int *pnHour, int *pnMinute, float *pfSecond, int *pnTZFlag)
| Fetch field value as date and time. More...
int | GetFieldAsInteger (const char *pszFName)
GIntBig | GetFieldAsInteger64 (const char *pszFName)
double | GetFieldAsDouble (const char *pszFName)
const char * | GetFieldAsString (const char *pszFName)
const int * | GetFieldAsIntegerList (const char *pszFName, int *pnCount)
const GIntBig * | GetFieldAsInteger64List (const char *pszFName, int *pnCount)
const double * | GetFieldAsDoubleList (const char *pszFName, int *pnCount)
char ** | GetFieldAsStringList (const char *pszFName)
void | SetField (int i, int nValue)
| Set field to integer value. More...
void | SetField (int i, GIntBig nValue)
| Set field to 64 bit integer value. More...
void | SetField (int i, double dfValue)
| Set field to double value. More...
void | SetField (int i, const char *pszValue)
| Set field to string value. More...
void | SetField (int i, int nCount, int *panValues)
| Set field to list of integers value. More...
void | SetField (int i, int nCount, const GIntBig *panValues)
| Set field to list of 64 bit integers value. More...
void | SetField (int i, int nCount, double *padfValues)
| Set field to list of doubles value. More...
void | SetField (int i, char **papszValues)
| Set field to list of strings value. More...
void | SetField (int i, OGRField *puValue)
| Set field. More...
void | SetField (int i, int nCount, GByte *pabyBinary)
| Set field to binary data. More...
void | SetField (int i, int nYear, int nMonth, int nDay, int nHour=0, int nMinute=0, float fSecond=0.f, int nTZFlag=0)
| Set field to date. More...
void | SetField (const char *pszFName, int nValue)
void | SetField (const char *pszFName, GIntBig nValue)
void | SetField (const char *pszFName, double dfValue)
void | SetField (const char *pszFName, const char *pszValue)
void | SetField (const char *pszFName, int nCount, int *panValues)
void | SetField (const char *pszFName, int nCount, const GIntBig *panValues)
void | SetField (const char *pszFName, int nCount, double *padfValues)
void | SetField (const char *pszFName, char **papszValues)
void | SetField (const char *pszFName, OGRField *puValue)
void | SetField (const char *pszFName, int nYear, int nMonth, int nDay, int nHour=0, int nMinute=0, float fSecond=0.f, int nTZFlag=0)
GIntBig | GetFID ()
| Get feature identifier. More...
virtual OGRErr | SetFID (GIntBig nFIDIn)
| Set the feature identifier. More...
void | DumpReadable (FILE *, char **papszOptions=NULL)
| Dump this feature in a human readable form. More...
OGRErr | SetFrom (OGRFeature *, int=TRUE)
| Set one feature from another. More...
OGRErr | SetFrom (OGRFeature *, int *, int=TRUE)
| Set one feature from another. More...
OGRErr | SetFieldsFrom (OGRFeature *, int *, int=TRUE)
| Set fields from another feature. More...
OGRErr | RemapFields (OGRFeatureDefn *poNewDefn, int *panRemapSource)
OGRErr | RemapGeomFields (OGRFeatureDefn *poNewDefn, int *panRemapSource)
int | Validate (int nValidateFlags, int bEmitError)
| Validate that a feature meets constraints of its schema. More...
void | FillUnsetWithDefault (int bNotNullableOnly, char **papszOptions)
| Fill unset fields with default values that might be defined. More...
virtual const char * | GetStyleString ()
| Fetch style string for this feature. More...
virtual void | SetStyleString (const char *)
| Set feature style string. More...
virtual void | SetStyleStringDirectly (char *)
| Set feature style string. More...
virtual OGRStyleTable * | GetStyleTable ()
virtual void | SetStyleTable (OGRStyleTable *poStyleTable)
virtual void | SetStyleTableDirectly (OGRStyleTable *poStyleTable)
const char * | GetNativeData () const
| Returns the native data for the feature. More...
const char * | GetNativeMediaType () const
| Returns the native media type for the feature. More...
void | SetNativeData (const char *pszNativeData)
| Sets the native data for the feature. More...
void | SetNativeMediaType (const char *pszNativeMediaType)
| Sets the native media type for the feature. More...

## Static Public Member Functions
static OGRFeature * | CreateFeature (OGRFeatureDefn *)
| Feature factory. More...
static void | DestroyFeature (OGRFeature *)
| Destroy feature. More...

## Protected Attributes
char * | m_pszStyleString
OGRStyleTable * | m_poStyleTable
char * | m_pszTmpFieldValue

## Detailed Description

A simple feature, including geometry and attributes.

## Constructor & Destructor Documentation

OGRFeature::OGRFeature | ( | OGRFeatureDefn * | poDefnIn | ) |

Constructor.

Note that the OGRFeature will increment the reference count of it's defining OGRFeatureDefn. Destruction of the OGRFeatureDefn before destruction of all OGRFeatures that depend on it is likely to result in a crash.

This method is the same as the C function OGR_F_Create().

Parameters

  poDefnIn | feature class (layer) definition to which the feature will adhere.

## Member Function Documentation

OGRFeature * OGRFeature::Clone | ( |  | ) |

Duplicate feature.

The newly created feature is owned by the caller, and will have it's own reference to the OGRFeatureDefn.

This method is the same as the C function OGR_F_Clone().

Returns
  new feature, exactly matching this feature. Or, starting with GDAL 2.1, NULL in case of out of memory situation.

OGRFeature * OGRFeature::CreateFeature | ( | OGRFeatureDefn * | poDefn | ) |
| static

Feature factory.

This is essentially a feature factory, useful for applications creating features but wanting to ensure they are created out of the OGR/GDAL heap.

This method is the same as the C function OGR_F_Create().

Parameters

  poDefn | Feature definition defining schema.

Returns
  new feature object with null fields and no geometry, or, starting with GDAL 2.1, NULL in case of out of memory situation. May be deleted with DestroyFeature().

void OGRFeature::DestroyFeature | ( | OGRFeature * | poFeature | ) |
| static

Destroy feature.

The feature is deleted, but within the context of the GDAL/OGR heap. This is necessary when higher level applications use GDAL/OGR from a DLL and they want to delete a feature created within the DLL. If the delete is done in the calling application the memory will be freed onto the application heap which is inappropriate.

This method is the same as the C function OGR_F_Destroy().

Parameters

  poFeature | the feature to delete.

void OGRFeature::DumpReadable | ( | FILE * | fpOut,
|  | char ** | papszOptions = `NULL`
| ) |  |

Dump this feature in a human readable form.

This dumps the attributes, and geometry; however, it doesn't definition information (other than field types and names), nor does it report the geometry spatial reference system.

A few options can be defined to change the default dump :

- DISPLAY_FIELDS=NO : to hide the dump of the attributes
- DISPLAY_STYLE=NO : to hide the dump of the style string
- DISPLAY_GEOMETRY=NO : to hide the dump of the geometry
- DISPLAY_GEOMETRY=SUMMARY : to get only a summary of the geometry

This method is the same as the C function OGR_F_DumpReadable().

Parameters

  fpOut | the stream to write to, such as stdout. If NULL stdout will be used.
  papszOptions | NULL terminated list of options (may be NULL)

OGRBoolean OGRFeature::Equal | ( | OGRFeature * | poFeature | ) |
| virtual

Test if two features are the same.

Two features are considered equal if the share them (pointer equality) same OGRFeatureDefn, have the same field values, and the same geometry (as tested by OGRGeometry::Equal()) as well as the same feature id.

This method is the same as the C function OGR_F_Equal().

Parameters

  poFeature | the other feature to test this one against.

Returns
  TRUE if they are equal, otherwise FALSE.

void OGRFeature::FillUnsetWithDefault | ( | int | bNotNullableOnly,
|  | char ** | papszOptions
| ) |  |

Fill unset fields with default values that might be defined.

This method is the same as the C function OGR_F_FillUnsetWithDefault().

Parameters

  bNotNullableOnly | if we should fill only unset fields with a not-null constraint.
  papszOptions | unused currently. Must be set to NULL.

Since
  GDAL 2.0

OGRFeatureDefn * OGRFeature::GetDefnRef | ( |  | ) |
| inline

Fetch feature definition.

This method is the same as the C function OGR_F_GetDefnRef().

Returns
  a reference to the feature definition object.

GIntBig OGRFeature::GetFID | ( |  | ) |
| inline

Get feature identifier.

This method is the same as the C function OGR_F_GetFID(). Note: since GDAL 2.0, this method returns a GIntBig (previously a long)

Returns
  feature id or OGRNullFID if none has been assigned.

GByte * OGRFeature::GetFieldAsBinary | ( | int | iField,
|  | int * | pnBytes
| ) |  |

Fetch field value as binary data.

This method only works for OFTBinary and OFTString fields.

This method is the same as the C function OGR_F_GetFieldAsBinary().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.
  pnBytes | location to put the number of bytes returned.

Returns
  the field value. This data is internal, and should not be modified, or freed. Its lifetime may be very brief.

int OGRFeature::GetFieldAsDateTime | ( | int | iField,
|  | int * | pnYear,
|  | int * | pnMonth,
|  | int * | pnDay,
|  | int * | pnHour,
|  | int * | pnMinute,
|  | float * | pfSecond,
|  | int * | pnTZFlag
| ) |  |

Fetch field value as date and time.

Currently this method only works for OFTDate, OFTTime and OFTDateTime fields.

This method is the same as the C function OGR_F_GetFieldAsDateTime().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.
  pnYear | (including century)
  pnMonth | (1-12)
  pnDay | (1-31)
  pnHour | (0-23)
  pnMinute | (0-59)
  pfSecond | (0-59 with millisecond accuracy)
  pnTZFlag | (0=unknown, 1=localtime, 100=GMT, see data model for details)

Returns
  TRUE on success or FALSE on failure.

double OGRFeature::GetFieldAsDouble | ( | int | iField | ) |

Fetch field value as a double.

OFTString features will be translated using CPLAtof(). OFTInteger and OFTInteger64 fields will be cast to double. Other field types, or errors will result in a return value of zero.

This method is the same as the C function OGR_F_GetFieldAsDouble().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns
  the field value.

const double * OGRFeature::GetFieldAsDoubleList | ( | int | iField,
|  | int * | pnCount
| ) |  |

Fetch field value as a list of doubles.

Currently this method only works for OFTRealList fields.

This method is the same as the C function OGR_F_GetFieldAsDoubleList().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.
  pnCount | an integer to put the list count (number of doubles) into.

Returns
  the field value. This list is internal, and should not be modified, or freed. Its lifetime may be very brief. If *pnCount is zero on return the returned pointer may be NULL or non-NULL.

int OGRFeature::GetFieldAsInteger | ( | int | iField | ) |

Fetch field value as integer.

OFTString features will be translated using atoi(). OFTReal fields will be cast to integer. OFTInteger64 are demoted to 32 bit, with clamping if out-of-range. Other field types, or errors will result in a return value of zero.

This method is the same as the C function OGR_F_GetFieldAsInteger().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns
  the field value.

GIntBig OGRFeature::GetFieldAsInteger64 | ( | int | iField | ) |

Fetch field value as integer 64 bit.

OFTInteger are promoted to 64 bit. OFTString features will be translated using CPLAtoGIntBig(). OFTReal fields will be cast to integer. Other field types, or errors will result in a return value of zero.

This method is the same as the C function OGR_F_GetFieldAsInteger64().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns
  the field value.

Since
  GDAL 2.0

const GIntBig * OGRFeature::GetFieldAsInteger64List | ( | int | iField,
|  | int * | pnCount
| ) |  |

Fetch field value as a list of 64 bit integers.

Currently this method only works for OFTInteger64List fields.

This method is the same as the C function OGR_F_GetFieldAsInteger64List().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.
  pnCount | an integer to put the list count (number of integers) into.

Returns
  the field value. This list is internal, and should not be modified, or freed. Its lifetime may be very brief. If *pnCount is zero on return the returned pointer may be NULL or non-NULL.

Since
  GDAL 2.0

const int * OGRFeature::GetFieldAsIntegerList | ( | int | iField,
|  | int * | pnCount
| ) |  |

Fetch field value as a list of integers.

Currently this method only works for OFTIntegerList fields.

This method is the same as the C function OGR_F_GetFieldAsIntegerList().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.
  pnCount | an integer to put the list count (number of integers) into.

Returns
  the field value. This list is internal, and should not be modified, or freed. Its lifetime may be very brief. If *pnCount is zero on return the returned pointer may be NULL or non-NULL.

const char * OGRFeature::GetFieldAsString | ( | int | iField | ) |

Fetch field value as a string.

OFTReal and OFTInteger fields will be translated to string using sprintf(), but not necessarily using the established formatting rules. Other field types, or errors will result in a return value of zero.

This method is the same as the C function OGR_F_GetFieldAsString().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns
  the field value. This string is internal, and should not be modified, or freed. Its lifetime may be very brief.

char ** OGRFeature::GetFieldAsStringList | ( | int | iField | ) |

Fetch field value as a list of strings.

Currently this method only works for OFTStringList fields.

The returned list is terminated by a NULL pointer. The number of elements can also be calculated using CSLCount().

This method is the same as the C function OGR_F_GetFieldAsStringList().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns
  the field value. This list is internal, and should not be modified, or freed. Its lifetime may be very brief.

int OGRFeature::GetFieldCount | ( |  | ) |
| inline

Fetch number of fields on this feature.

This will always be the same as the field count for the OGRFeatureDefn.

This method is the same as the C function OGR_F_GetFieldCount().

Returns
  count of fields.

OGRFieldDefn * OGRFeature::GetFieldDefnRef | ( | int | iField | ) |
| inline

Fetch definition for this field.

This method is the same as the C function OGR_F_GetFieldDefnRef().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns
  the field definition (from the OGRFeatureDefn). This is an internal reference, and should not be deleted or modified.

int OGRFeature::GetFieldIndex | ( | const char * | pszName | ) |
| inline

Fetch the field index given field name.

This is a cover for the OGRFeatureDefn::GetFieldIndex() method.

This method is the same as the C function OGR_F_GetFieldIndex().

Parameters

  pszName | the name of the field to search for.

Returns
  the field index, or -1 if no matching field is found.

OGRGeometry * OGRFeature::GetGeometryRef | ( |  | ) |

Fetch pointer to feature geometry.

This method is the same as the C function OGR_F_GetGeometryRef().

Starting with GDAL 1.11, this is equivalent to calling OGRFeature::GetGeomFieldRef(0).

Returns
  pointer to internal feature geometry. This object should not be modified.

int OGRFeature::GetGeomFieldCount | ( |  | ) |
| inline

Fetch number of geometry fields on this feature.

This will always be the same as the geometry field count for the OGRFeatureDefn.

This method is the same as the C function OGR_F_GetGeomFieldCount().

Returns
  count of geometry fields.

Since
  GDAL 1.11

OGRGeomFieldDefn * OGRFeature::GetGeomFieldDefnRef | ( | int | iGeomField | ) |
| inline

Fetch definition for this geometry field.

This method is the same as the C function OGR_F_GetGeomFieldDefnRef().

Parameters

  iGeomField | the field to fetch, from 0 to GetGeomFieldCount()-1.

Returns
  the field definition (from the OGRFeatureDefn). This is an internal reference, and should not be deleted or modified.

Since
  GDAL 1.11

int OGRFeature::GetGeomFieldIndex | ( | const char * | pszName | ) |
| inline

Fetch the geometry field index given geometry field name.

This is a cover for the OGRFeatureDefn::GetGeomFieldIndex() method.

This method is the same as the C function OGR_F_GetGeomFieldIndex().

Parameters

  pszName | the name of the geometry field to search for.

Returns
  the geometry field index, or -1 if no matching geometry field is found.

Since
  GDAL 1.11

OGRGeometry * OGRFeature::GetGeomFieldRef | ( | int | iField | ) |

Fetch pointer to feature geometry.

This method is the same as the C function OGR_F_GetGeomFieldRef().

Parameters

  iField | geometry field to get.

Returns
  pointer to internal feature geometry. This object should not be modified.

Since
  GDAL 1.11

OGRGeometry * OGRFeature::GetGeomFieldRef | ( | const char * | pszFName | ) |

Fetch pointer to feature geometry.

Parameters

  pszFName | name of geometry field to get.

Returns
  pointer to internal feature geometry. This object should not be modified.

Since
  GDAL 1.11

const char * OGRFeature::GetNativeData | ( |  | ) | const
| inline

Returns the native data for the feature.

The native data is the representation in a "natural" form that comes from the driver that created this feature, or that is aimed at an output driver. The native data may be in different format, which is indicated by GetNativeMediaType().

Note that most drivers do not support storing the native data in the feature object, and if they do, generally the NATIVE_DATA open option must be passed at dataset opening.

The "native data" does not imply it is something more performant or powerful than what can be obtained with the rest of the API, but it may be useful in round-tripping scenarios where some characteristics of the underlying format are not captured otherwise by the OGR abstraction.

This function is the same as the C function OGR_F_GetNativeData().

Returns
  a string with the native data, or NULL if there is none.

Since
  GDAL 2.1

See also
  https://trac.osgeo.org/gdal/wiki/rfc60_improved_roundtripping_in_ogr

const char * OGRFeature::GetNativeMediaType | ( |  | ) | const
| inline

Returns the native media type for the feature.

The native media type is the identifier for the format of the native data. It follows the IANA RFC 2045 (see https://en.wikipedia.org/wiki/Media_type), e.g. "application/vnd.geo+json" for JSon.

This function is the same as the C function OGR_F_GetNativeMediaType().

Returns
  a string with the native media type, or NULL if there is none.

Since
  GDAL 2.1

See also
  https://trac.osgeo.org/gdal/wiki/rfc60_improved_roundtripping_in_ogr

OGRField * OGRFeature::GetRawFieldRef | ( | int | iField | ) |
| inline

Fetch a pointer to the internal field value given the index.

This method is the same as the C function OGR_F_GetRawFieldRef().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns
  the returned pointer is to an internal data structure, and should not be freed, or modified.

const char * OGRFeature::GetStyleString | ( |  | ) |
| virtual

Fetch style string for this feature.

Set the OGR Feature Style Specification for details on the format of this string, and ogr_featurestyle.h for services available to parse it.

This method is the same as the C function OGR_F_GetStyleString().

Returns
  a reference to a representation in string format, or NULL if there isn't one.

int OGRFeature::IsFieldSet | ( | int | iField | ) |

Test if a field has ever been assigned a value or not.

This method is the same as the C function OGR_F_IsFieldSet().

Parameters

  iField | the field to test.

Returns
  TRUE if the field has been set, otherwise false.

OGRErr OGRFeature::SetFID | ( | GIntBig | nFIDIn | ) |
| virtual

Set the feature identifier.

For specific types of features this operation may fail on illegal features ids. Generally it always succeeds. Feature ids should be greater than or equal to zero, with the exception of OGRNullFID (-1) indicating that the feature id is unknown.

This method is the same as the C function OGR_F_SetFID().

Parameters

  nFIDIn | the new feature identifier value to assign.

Returns
  On success OGRERR_NONE, or on failure some other value.

void OGRFeature::SetField | ( | int | iField,
|  | int | nValue
| ) |  |

Set field to integer value.

OFTInteger, OFTInteger64 and OFTReal fields will be set directly. OFTString fields will be assigned a string representation of the value, but not necessarily taking into account formatting constraints on this field. Other field types may be unaffected.

This method is the same as the C function OGR_F_SetFieldInteger().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.
  nValue | the value to assign.

void OGRFeature::SetField | ( | int | iField,
|  | GIntBig | nValue
| ) |  |

Set field to 64 bit integer value.

OFTInteger, OFTInteger64 and OFTReal fields will be set directly. OFTString fields will be assigned a string representation of the value, but not necessarily taking into account formatting constraints on this field. Other field types may be unaffected.

This method is the same as the C function OGR_F_SetFieldInteger64().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.
  nValue | the value to assign.

Since
  GDAL 2.0

void OGRFeature::SetField | ( | int | iField,
|  | double | dfValue
| ) |  |

Set field to double value.

OFTInteger, OFTInteger64 and OFTReal fields will be set directly. OFTString fields will be assigned a string representation of the value, but not necessarily taking into account formatting constraints on this field. Other field types may be unaffected.

This method is the same as the C function OGR_F_SetFieldDouble().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.
  dfValue | the value to assign.

void OGRFeature::SetField | ( | int | iField,
|  | const char * | pszValue
| ) |  |

Set field to string value.

OFTInteger fields will be set based on an atoi() conversion of the string. OFTInteger64 fields will be set based on an CPLAtoGIntBig() conversion of the string. OFTReal fields will be set based on an CPLAtof() conversion of the string. Other field types may be unaffected.

This method is the same as the C function OGR_F_SetFieldString().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.
  pszValue | the value to assign.

void OGRFeature::SetField | ( | int | iField,
|  | int | nCount,
|  | int * | panValues
| ) |  |

Set field to list of integers value.

This method currently on has an effect of OFTIntegerList, OFTInteger64List and OFTRealList fields.

This method is the same as the C function OGR_F_SetFieldIntegerList().

Parameters

  iField | the field to set, from 0 to GetFieldCount()-1.
  nCount | the number of values in the list being assigned.
  panValues | the values to assign.

void OGRFeature::SetField | ( | int | iField,
|  | int | nCount,
|  | const GIntBig * | panValues
| ) |  |

Set field to list of 64 bit integers value.

This method currently on has an effect of OFTIntegerList, OFTInteger64List and OFTRealList fields.

This method is the same as the C function OGR_F_SetFieldIntege64rList().

Parameters

  iField | the field to set, from 0 to GetFieldCount()-1.
  nCount | the number of values in the list being assigned.
  panValues | the values to assign.

Since
  GDAL 2.0

void OGRFeature::SetField | ( | int | iField,
|  | int | nCount,
|  | double * | padfValues
| ) |  |

Set field to list of doubles value.

This method currently on has an effect of OFTIntegerList, OFTInteger64List, OFTRealList fields.

This method is the same as the C function OGR_F_SetFieldDoubleList().

Parameters

  iField | the field to set, from 0 to GetFieldCount()-1.
  nCount | the number of values in the list being assigned.
  padfValues | the values to assign.

void OGRFeature::SetField | ( | int | iField,
|  | char ** | papszValues
| ) |  |

Set field to list of strings value.

This method currently on has an effect of OFTStringList fields.

This method is the same as the C function OGR_F_SetFieldStringList().

Parameters

  iField | the field to set, from 0 to GetFieldCount()-1.
  papszValues | the values to assign.

void OGRFeature::SetField | ( | int | iField,
|  | OGRField * | puValue
| ) |  |

Set field.

The passed value OGRField must be of exactly the same type as the target field, or an application crash may occur. The passed value is copied, and will not be affected. It remains the responsibility of the caller.

This method is the same as the C function OGR_F_SetFieldRaw().

Parameters

  iField | the field to fetch, from 0 to GetFieldCount()-1.
  puValue | the value to assign.

void OGRFeature::SetField | ( | int | iField,
|  | int | nBytes,
|  | GByte * | pabyData
| ) |  |

Set field to binary data.

This method currently on has an effect of OFTBinary fields.

This method is the same as the C function OGR_F_SetFieldBinary().

Parameters

  iField | the field to set, from 0 to GetFieldCount()-1.
  nBytes | bytes of data being set.
  pabyData | the raw data being applied.

void OGRFeature::SetField | ( | int | iField,
|  | int | nYear,
|  | int | nMonth,
|  | int | nDay,
|  | int | nHour = `0`,
|  | int | nMinute = `0`,
|  | float | fSecond = `0.f`,
|  | int | nTZFlag = `0`
| ) |  |

Set field to date.

This method currently only has an effect for OFTDate, OFTTime and OFTDateTime fields.

This method is the same as the C function OGR_F_SetFieldDateTime().

Parameters

  iField | the field to set, from 0 to GetFieldCount()-1.
  nYear | (including century)
  nMonth | (1-12)
  nDay | (1-31)
  nHour | (0-23)
  nMinute | (0-59)
  fSecond | (0-59, with millisecond accuracy)
  nTZFlag | (0=unknown, 1=localtime, 100=GMT, see data model for details)

OGRErr OGRFeature::SetFieldsFrom | ( | OGRFeature * | poSrcFeature,
|  | int * | panMap,
|  | int | bForgiving = `TRUE`
| ) |  |

Set fields from another feature.

Overwrite the fields of this feature from the attributes of another. The FID and the style string are not set. The poSrcFeature does not need to have the same OGRFeatureDefn. Field values are copied according to the provided indices map. Field types do not have to exactly match. SetField() method conversion rules will be applied as needed. This is more efficient than OGR_F_SetFrom() in that this doesn't lookup the fields by their names. Particularly useful when the field names don't match.

Parameters

  poSrcFeature | the feature from which geometry, and field values will be copied.
  panMap | Array of the indices of the feature's fields stored at the corresponding index of the source feature's fields. A value of -1 should be used to ignore the source's field. The array should not be NULL and be as long as the number of fields in the source feature.
  bForgiving | TRUE if the operation should continue despite lacking output fields matching some of the source fields.

Returns
  OGRERR_NONE if the operation succeeds, even if some values are not transferred, otherwise an error code.

OGRErr OGRFeature::SetFrom | ( | OGRFeature * | poSrcFeature,
|  | int | bForgiving = `TRUE`
| ) |  |

Set one feature from another.

Overwrite the contents of this feature from the geometry and attributes of another. The poSrcFeature does not need to have the same OGRFeatureDefn. Field values are copied by corresponding field names. Field types do not have to exactly match. SetField() method conversion rules will be applied as needed.

This method is the same as the C function OGR_F_SetFrom().

Parameters

  poSrcFeature | the feature from which geometry, and field values will be copied.
  bForgiving | TRUE if the operation should continue despite lacking output fields matching some of the source fields.

Returns
  OGRERR_NONE if the operation succeeds, even if some values are not transferred, otherwise an error code.

OGRErr OGRFeature::SetFrom | ( | OGRFeature * | poSrcFeature,
|  | int * | panMap,
|  | int | bForgiving = `TRUE`
| ) |  |

Set one feature from another.

Overwrite the contents of this feature from the geometry and attributes of another. The poSrcFeature does not need to have the same OGRFeatureDefn. Field values are copied according to the provided indices map. Field types do not have to exactly match. SetField() method conversion rules will be applied as needed. This is more efficient than OGR_F_SetFrom() in that this doesn't lookup the fields by their names. Particularly useful when the field names don't match.

This method is the same as the C function OGR_F_SetFromWithMap().

Parameters

  poSrcFeature | the feature from which geometry, and field values will be copied.
  panMap | Array of the indices of the feature's fields stored at the corresponding index of the source feature's fields. A value of -1 should be used to ignore the source's field. The array should not be NULL and be as long as the number of fields in the source feature.
  bForgiving | TRUE if the operation should continue despite lacking output fields matching some of the source fields.

Returns
  OGRERR_NONE if the operation succeeds, even if some values are not transferred, otherwise an error code.

OGRErr OGRFeature::SetGeometry | ( | OGRGeometry * | poGeomIn | ) |

Set feature geometry.

This method updates the features geometry, and operate exactly as SetGeometryDirectly(), except that this method does not assume ownership of the passed geometry, but instead makes a copy of it.

This method is the same as the C function OGR_F_SetGeometry().

Parameters

  poGeomIn | new geometry to apply to feature. Passing NULL value here is correct and it will result in deallocation of currently assigned geometry without assigning new one.

Returns
  OGRERR_NONE if successful, or OGR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the OGRFeatureDefn (checking not yet implemented).

OGRErr OGRFeature::SetGeometryDirectly | ( | OGRGeometry * | poGeomIn | ) |

Set feature geometry.

This method updates the features geometry, and operate exactly as SetGeometry(), except that this method assumes ownership of the passed geometry (even in case of failure of that function).

This method is the same as the C function OGR_F_SetGeometryDirectly().

Parameters

  poGeomIn | new geometry to apply to feature. Passing NULL value here is correct and it will result in deallocation of currently assigned geometry without assigning new one.

Returns
  OGRERR_NONE if successful, or OGR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the OGRFeatureDefn (checking not yet implemented).

OGRErr OGRFeature::SetGeomField | ( | int | iField,
|  | OGRGeometry * | poGeomIn
| ) |  |

Set feature geometry of a specified geometry field.

This method updates the features geometry, and operate exactly as SetGeomFieldDirectly(), except that this method does not assume ownership of the passed geometry, but instead makes a copy of it.

This method is the same as the C function OGR_F_SetGeomField().

Parameters

  iField | geometry field to set.
  poGeomIn | new geometry to apply to feature. Passing NULL value here is correct and it will result in deallocation of currently assigned geometry without assigning new one.

Returns
  OGRERR_NONE if successful, or OGRERR_FAILURE if the index is invalid, or OGR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the OGRFeatureDefn (checking not yet implemented).

Since
  GDAL 1.11

OGRErr OGRFeature::SetGeomFieldDirectly | ( | int | iField,
|  | OGRGeometry * | poGeomIn
| ) |  |

Set feature geometry of a specified geometry field.

This method updates the features geometry, and operate exactly as SetGeomField(), except that this method assumes ownership of the passed geometry (even in case of failure of that function).

This method is the same as the C function OGR_F_SetGeomFieldDirectly().

Parameters

  iField | geometry field to set.
  poGeomIn | new geometry to apply to feature. Passing NULL value here is correct and it will result in deallocation of currently assigned geometry without assigning new one.

Returns
  OGRERR_NONE if successful, or OGRERR_FAILURE if the index is invalid, or OGRERR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the OGRFeatureDefn (checking not yet implemented).

Since
  GDAL 1.11

void OGRFeature::SetNativeData | ( | const char * | pszNativeData | ) |

Sets the native data for the feature.

The native data is the representation in a "natural" form that comes from the driver that created this feature, or that is aimed at an output driver. The native data may be in different format, which is indicated by GetNativeMediaType().

This function is the same as the C function OGR_F_SetNativeData().

Parameters

  pszNativeData | a string with the native data, or NULL if there is none.

Since
  GDAL 2.1

See also
  https://trac.osgeo.org/gdal/wiki/rfc60_improved_roundtripping_in_ogr

void OGRFeature::SetNativeMediaType | ( | const char * | pszNativeMediaType | ) |

Sets the native media type for the feature.

The native media type is the identifier for the format of the native data. It follows the IANA RFC 2045 (see https://en.wikipedia.org/wiki/Media_type), e.g. "application/vnd.geo+json" for JSon.

This function is the same as the C function OGR_F_SetNativeMediaType().

Parameters

  pszNativeMediaType | a string with the native media type, or NULL if there is none.

Since
  GDAL 2.1

See also
  https://trac.osgeo.org/gdal/wiki/rfc60_improved_roundtripping_in_ogr

void OGRFeature::SetStyleString | ( | const char * | pszString | ) |
| virtual

Set feature style string.

This method operate exactly as OGRFeature::SetStyleStringDirectly() except that it does not assume ownership of the passed string, but instead makes a copy of it.

This method is the same as the C function OGR_F_SetStyleString().

Parameters

  pszString | the style string to apply to this feature, cannot be NULL.

void OGRFeature::SetStyleStringDirectly | ( | char * | pszString | ) |
| virtual

Set feature style string.

This method operate exactly as OGRFeature::SetStyleString() except that it assumes ownership of the passed string.

This method is the same as the C function OGR_F_SetStyleStringDirectly().

Parameters

  pszString | the style string to apply to this feature, cannot be NULL.

OGRGeometry * OGRFeature::StealGeometry | ( |  | ) |

Take away ownership of geometry.

Fetch the geometry from this feature, and clear the reference to the geometry on the feature. This is a mechanism for the application to take over ownership of the geometry from the feature without copying. Sort of an inverse to SetGeometryDirectly().

After this call the OGRFeature will have a NULL geometry.

Returns
  the pointer to the geometry.

void OGRFeature::UnsetField | ( | int | iField | ) |

Clear a field, marking it as unset.

This method is the same as the C function OGR_F_UnsetField().

Parameters

  iField | the field to unset.

int OGRFeature::Validate | ( | int | nValidateFlags,
|  | int | bEmitError
| ) |  |

Validate that a feature meets constraints of its schema.

The scope of test is specified with the nValidateFlags parameter.

Regarding OGR_F_VAL_WIDTH, the test is done assuming the string width must be interpreted as the number of UTF-8 characters. Some drivers might interpret the width as the number of bytes instead. So this test is rather conservative (if it fails, then it will fail for all interpretations).

This method is the same as the C function OGR_F_Validate().

Parameters

  nValidateFlags | OGR_F_VAL_ALL or combination of OGR_F_VAL_NULL, OGR_F_VAL_GEOM_TYPE, OGR_F_VAL_WIDTH and OGR_F_VAL_ALLOW_NULL_WHEN_DEFAULT, OGR_F_VAL_ALLOW_DIFFERENT_GEOM_DIM with '|' operator
  bEmitError | TRUE if a CPLError() must be emitted when a check fails

Returns
  TRUE if all enabled validation tests pass.

Since
  GDAL 2.0

The documentation for this class was generated from the following files:

- ogr_feature.h
- ogrfeature.cpp

Generated for GDAL by 1.8.8.